"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[4863],{56224:(e,t,n)=>{n.d(t,{ZP:()=>i,d$:()=>o});var r=n(85893),a=n(11151);const o=[];function s(e){const t={admonition:"admonition",em:"em",p:"p",...(0,a.a)(),...e.components};return(0,r.jsx)(t.admonition,{type:"info",children:(0,r.jsxs)(t.p,{children:[(0,r.jsx)(t.em,{children:"example-outpost"})," is used as a placeholder for the outpost name.\n",(0,r.jsx)(t.em,{children:"authentik.company"})," is used as a placeholder for the authentik install.\n",(0,r.jsx)(t.em,{children:"app.company"})," is used as a placeholder for the external domain for the application.\n",(0,r.jsx)(t.em,{children:"outpost.company"})," is used as a placeholder for the outpost. When using the embedded outpost, this can be the same as ",(0,r.jsx)(t.em,{children:"authentik.company"})]})})}function i(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(s,{...e})}):s(e)}},91530:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>x,contentTitle:()=>m,default:()=>y,frontMatter:()=>_,metadata:()=>g,toc:()=>k});var r=n(85893),a=n(11151),o=n(74866),s=n(85162),i=n(56224);function u(e){const t={code:"code",pre:"pre",...(0,a.a)(),...e.components};return(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{children:"# Upgrade WebSocket if requested, otherwise use keepalive\nmap $http_upgrade $connection_upgrade_keepalive {\n    default upgrade;\n    ''      '';\n}\n\nserver {\n    # SSL and VHost configuration\n    listen                  443 ssl http2;\n    server_name             _;\n\n    ssl_certificate         /etc/ssl/certs/ssl-cert-snakeoil.pem;\n    ssl_certificate_key     /etc/ssl/private/ssl-cert-snakeoil.key;\n\n    # Increase buffer size for large headers\n    # This is needed only if you get 'upstream sent too big header while reading response\n    # header from upstream' error when trying to access an application protected by goauthentik\n    proxy_buffers 8 16k;\n    proxy_buffer_size 32k;\n\n    location / {\n        # Put your proxy_pass to your application here, and all the other statements you'll need\n        # proxy_pass http://localhost:5000;\n        # proxy_set_header Host $host;\n        # proxy_set_header ...\n        # Support for websocket\n        proxy_set_header Upgrade $http_upgrade;\n        proxy_set_header Connection $connection_upgrade_keepalive;\n\n        ##############################\n        # authentik-specific config\n        ##############################\n        auth_request     /outpost.goauthentik.io/auth/nginx;\n        error_page       401 = @goauthentik_proxy_signin;\n        auth_request_set $auth_cookie $upstream_http_set_cookie;\n        add_header       Set-Cookie $auth_cookie;\n\n        # translate headers from the outposts back to the actual upstream\n        auth_request_set $authentik_username $upstream_http_x_authentik_username;\n        auth_request_set $authentik_groups $upstream_http_x_authentik_groups;\n        auth_request_set $authentik_email $upstream_http_x_authentik_email;\n        auth_request_set $authentik_name $upstream_http_x_authentik_name;\n        auth_request_set $authentik_uid $upstream_http_x_authentik_uid;\n\n        proxy_set_header X-authentik-username $authentik_username;\n        proxy_set_header X-authentik-groups $authentik_groups;\n        proxy_set_header X-authentik-email $authentik_email;\n        proxy_set_header X-authentik-name $authentik_name;\n        proxy_set_header X-authentik-uid $authentik_uid;\n    }\n\n    # all requests to /outpost.goauthentik.io must be accessible without authentication\n    location /outpost.goauthentik.io {\n        proxy_pass              http://outpost.company:9000/outpost.goauthentik.io;\n        # ensure the host of this vserver matches your external URL you've configured\n        # in authentik\n        proxy_set_header        Host $host;\n        proxy_set_header        X-Original-URL $scheme://$http_host$request_uri;\n        add_header              Set-Cookie $auth_cookie;\n        auth_request_set        $auth_cookie $upstream_http_set_cookie;\n        proxy_pass_request_body off;\n        proxy_set_header        Content-Length \"\";\n    }\n\n    # Special location for when the /auth endpoint returns a 401,\n    # redirect to the /start URL which initiates SSO\n    location @goauthentik_proxy_signin {\n        internal;\n        add_header Set-Cookie $auth_cookie;\n        return 302 /outpost.goauthentik.io/start?rd=$request_uri;\n        # For domain level, use the below error_page to redirect to your authentik server with the full redirect path\n        # return 302 https://authentik.company/outpost.goauthentik.io/start?rd=$scheme://$http_host$request_uri;\n    }\n}\n"})})}function l(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(u,{...e})}):u(e)}function h(e){const t={a:"a",admonition:"admonition",code:"code",p:"p",pre:"pre",...(0,a.a)(),...e.components};return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsx)(t.p,{children:"Create a new ingress for the outpost"}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-yaml",children:"apiVersion: networking.k8s.io/v1\nkind: Ingress\nmetadata:\n    name: authentik-outpost\nspec:\n    rules:\n        - host: app.company\n          http:\n              paths:\n                  - path: /outpost.goauthentik.io\n                    pathType: Prefix\n                    backend:\n                        # Or, to use an external Outpost, create an ExternalName service and reference that here.\n                        # See https://kubernetes.io/docs/concepts/services-networking/service/#externalname\n                        service:\n                            name: ak-outpost-example-outpost\n                            port:\n                                number: 9000\n"})}),"\n",(0,r.jsx)(t.p,{children:"This ingress handles authentication requests, and the sign-in flow."}),"\n",(0,r.jsx)(t.p,{children:"Add these annotations to the ingress you want to protect"}),"\n",(0,r.jsx)(t.admonition,{type:"warning",children:(0,r.jsxs)(t.p,{children:["This configuration requires that you enable ",(0,r.jsx)(t.a,{href:"https://kubernetes.github.io/ingress-nginx/user-guide/nginx-configuration/configmap/#allow-snippet-annotations",children:(0,r.jsx)(t.code,{children:"allow-snippet-annotations"})}),", for example by setting ",(0,r.jsx)(t.code,{children:"controller.allowSnippetAnnotations"})," to ",(0,r.jsx)(t.code,{children:"true"})," in your helm values for the ingress-nginx installation."]})}),"\n",(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{className:"language-yaml",children:"metadata:\n    annotations:\n        # This should be the in-cluster DNS name for the authentik outpost service\n        # as when the external URL is specified here, nginx will overwrite some crucial headers\n        nginx.ingress.kubernetes.io/auth-url: |-\n            http://ak-outpost-example.authentik.svc.cluster.local:9000/outpost.goauthentik.io/auth/nginx\n        # If you're using domain-level auth, use the authentication URL instead of the application URL\n        nginx.ingress.kubernetes.io/auth-signin: |-\n            https://app.company/outpost.goauthentik.io/start?rd=$escaped_request_uri\n        nginx.ingress.kubernetes.io/auth-response-headers: |-\n            Set-Cookie,X-authentik-username,X-authentik-groups,X-authentik-email,X-authentik-name,X-authentik-uid\n        nginx.ingress.kubernetes.io/auth-snippet: |\n            proxy_set_header X-Forwarded-Host $http_host;\n"})})]})}function p(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(h,{...e})}):h(e)}function c(e){const t={code:"code",pre:"pre",...(0,a.a)(),...e.components};return(0,r.jsx)(t.pre,{children:(0,r.jsx)(t.code,{children:"# Upgrade WebSocket if requested, otherwise use keepalive\nmap $http_upgrade $connection_upgrade_keepalive {\n    default upgrade;\n    ''      '';\n}\n\n# Increase buffer size for large headers\n# This is needed only if you get 'upstream sent too big header while reading response\n# header from upstream' error when trying to access an application protected by goauthentik\nproxy_buffers 8 16k;\nproxy_buffer_size 32k;\n\n# Make sure not to redirect traffic to a port 4443\nport_in_redirect off;\n\nlocation / {\n    # Put your proxy_pass to your application here\n    proxy_pass          $forward_scheme://$server:$port;\n    # Set any other headers your application might need\n    # proxy_set_header Host $host;\n    # proxy_set_header ...\n    # Support for websocket\n    proxy_set_header Upgrade $http_upgrade;\n    proxy_set_header Connection $connection_upgrade_keepalive;\n\n    ##############################\n    # authentik-specific config\n    ##############################\n    auth_request     /outpost.goauthentik.io/auth/nginx;\n    error_page       401 = @goauthentik_proxy_signin;\n    auth_request_set $auth_cookie $upstream_http_set_cookie;\n    add_header       Set-Cookie $auth_cookie;\n\n    # translate headers from the outposts back to the actual upstream\n    auth_request_set $authentik_username $upstream_http_x_authentik_username;\n    auth_request_set $authentik_groups $upstream_http_x_authentik_groups;\n    auth_request_set $authentik_email $upstream_http_x_authentik_email;\n    auth_request_set $authentik_name $upstream_http_x_authentik_name;\n    auth_request_set $authentik_uid $upstream_http_x_authentik_uid;\n\n    proxy_set_header X-authentik-username $authentik_username;\n    proxy_set_header X-authentik-groups $authentik_groups;\n    proxy_set_header X-authentik-email $authentik_email;\n    proxy_set_header X-authentik-name $authentik_name;\n    proxy_set_header X-authentik-uid $authentik_uid;\n}\n\n# all requests to /outpost.goauthentik.io must be accessible without authentication\nlocation /outpost.goauthentik.io {\n    proxy_pass              http://outpost.company:9000/outpost.goauthentik.io;\n    # ensure the host of this vserver matches your external URL you've configured\n    # in authentik\n    proxy_set_header        Host $host;\n    proxy_set_header        X-Original-URL $scheme://$http_host$request_uri;\n    add_header              Set-Cookie $auth_cookie;\n    auth_request_set        $auth_cookie $upstream_http_set_cookie;\n    proxy_pass_request_body off;\n    proxy_set_header        Content-Length \"\";\n}\n\n# Special location for when the /auth endpoint returns a 401,\n# redirect to the /start URL which initiates SSO\nlocation @goauthentik_proxy_signin {\n    internal;\n    add_header Set-Cookie $auth_cookie;\n    return 302 /outpost.goauthentik.io/start?rd=$request_uri;\n    # For domain level, use the below error_page to redirect to your authentik server with the full redirect path\n    # return 302 https://authentik.company/outpost.goauthentik.io/start?rd=$scheme://$http_host$request_uri;\n}\n"})})}function d(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(c,{...e})}):c(e)}const _={},m="nginx",g={id:"providers/proxy/server_nginx",title:"nginx",description:"The configuration templates shown below apply to both single-application and domain-level forward auth.",source:"@site/docs/providers/proxy/server_nginx.mdx",sourceDirName:"providers/proxy",slug:"/providers/proxy/server_nginx",permalink:"/docs/providers/proxy/server_nginx",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/providers/proxy/server_nginx.mdx",tags:[],version:"current",frontMatter:{},sidebar:"docs",previous:{title:"Forward auth",permalink:"/docs/providers/proxy/forward_auth"},next:{title:"Traefik",permalink:"/docs/providers/proxy/server_traefik"}},x={},k=[...i.d$];function f(e){const t={h1:"h1",p:"p",...(0,a.a)(),...e.components};return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsx)(t.h1,{id:"nginx",children:"nginx"}),"\n",(0,r.jsx)(t.p,{children:"The configuration templates shown below apply to both single-application and domain-level forward auth."}),"\n","\n",(0,r.jsx)(i.ZP,{}),"\n",(0,r.jsxs)(o.Z,{defaultValue:"standalone-nginx",values:[{label:"Standalone nginx",value:"standalone-nginx"},{label:"Ingress",value:"ingress"},{label:"Nginx Proxy Manager",value:"proxy-manager"}],children:[(0,r.jsx)(s.Z,{value:"standalone-nginx",children:(0,r.jsx)(l,{})}),(0,r.jsx)(s.Z,{value:"ingress",children:(0,r.jsx)(p,{})}),(0,r.jsx)(s.Z,{value:"proxy-manager",children:(0,r.jsx)(d,{})})]})]})}function y(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,r.jsx)(t,{...e,children:(0,r.jsx)(f,{...e})}):f(e)}},85162:(e,t,n)=>{n.d(t,{Z:()=>s});n(67294);var r=n(90512);const a={tabItem:"tabItem_Ymn6"};var o=n(85893);function s(e){let{children:t,hidden:n,className:s}=e;return(0,o.jsx)("div",{role:"tabpanel",className:(0,r.Z)(a.tabItem,s),hidden:n,children:t})}},74866:(e,t,n)=>{n.d(t,{Z:()=>v});var r=n(67294),a=n(90512),o=n(12466),s=n(16550),i=n(20469),u=n(91980),l=n(67392),h=n(50012);function p(e){var t,n;return null!=(t=null==(n=r.Children.toArray(e).filter((e=>"\n"!==e)).map((e=>{if(!e||(0,r.isValidElement)(e)&&function(e){const{props:t}=e;return!!t&&"object"==typeof t&&"value"in t}(e))return e;throw new Error("Docusaurus error: Bad <Tabs> child <"+("string"==typeof e.type?e.type:e.type.name)+'>: all children of the <Tabs> component should be <TabItem>, and every <TabItem> should have a unique "value" prop.')})))?void 0:n.filter(Boolean))?t:[]}function c(e){const{values:t,children:n}=e;return(0,r.useMemo)((()=>{const e=null!=t?t:function(e){return p(e).map((e=>{let{props:{value:t,label:n,attributes:r,default:a}}=e;return{value:t,label:n,attributes:r,default:a}}))}(n);return function(e){const t=(0,l.l)(e,((e,t)=>e.value===t.value));if(t.length>0)throw new Error('Docusaurus error: Duplicate values "'+t.map((e=>e.value)).join(", ")+'" found in <Tabs>. Every value needs to be unique.')}(e),e}),[t,n])}function d(e){let{value:t,tabValues:n}=e;return n.some((e=>e.value===t))}function _(e){let{queryString:t=!1,groupId:n}=e;const a=(0,s.k6)(),o=function(e){let{queryString:t=!1,groupId:n}=e;if("string"==typeof t)return t;if(!1===t)return null;if(!0===t&&!n)throw new Error('Docusaurus error: The <Tabs> component groupId prop is required if queryString=true, because this value is used as the search param name. You can also provide an explicit value such as queryString="my-search-param".');return null!=n?n:null}({queryString:t,groupId:n});return[(0,u._X)(o),(0,r.useCallback)((e=>{if(!o)return;const t=new URLSearchParams(a.location.search);t.set(o,e),a.replace({...a.location,search:t.toString()})}),[o,a])]}function m(e){const{defaultValue:t,queryString:n=!1,groupId:a}=e,o=c(e),[s,u]=(0,r.useState)((()=>function(e){var t;let{defaultValue:n,tabValues:r}=e;if(0===r.length)throw new Error("Docusaurus error: the <Tabs> component requires at least one <TabItem> children component");if(n){if(!d({value:n,tabValues:r}))throw new Error('Docusaurus error: The <Tabs> has a defaultValue "'+n+'" but none of its children has the corresponding value. Available values are: '+r.map((e=>e.value)).join(", ")+". If you intend to show no default tab, use defaultValue={null} instead.");return n}const a=null!=(t=r.find((e=>e.default)))?t:r[0];if(!a)throw new Error("Unexpected error: 0 tabValues");return a.value}({defaultValue:t,tabValues:o}))),[l,p]=_({queryString:n,groupId:a}),[m,g]=function(e){let{groupId:t}=e;const n=function(e){return e?"docusaurus.tab."+e:null}(t),[a,o]=(0,h.Nk)(n);return[a,(0,r.useCallback)((e=>{n&&o.set(e)}),[n,o])]}({groupId:a}),x=(()=>{const e=null!=l?l:m;return d({value:e,tabValues:o})?e:null})();(0,i.Z)((()=>{x&&u(x)}),[x]);return{selectedValue:s,selectValue:(0,r.useCallback)((e=>{if(!d({value:e,tabValues:o}))throw new Error("Can't select invalid tab value="+e);u(e),p(e),g(e)}),[p,g,o]),tabValues:o}}var g=n(72389);const x={tabList:"tabList__CuJ",tabItem:"tabItem_LNqP"};var k=n(85893);function f(e){let{className:t,block:n,selectedValue:r,selectValue:s,tabValues:i}=e;const u=[],{blockElementScrollPositionUntilNextRender:l}=(0,o.o5)(),h=e=>{const t=e.currentTarget,n=u.indexOf(t),a=i[n].value;a!==r&&(l(t),s(a))},p=e=>{var t;let n=null;switch(e.key){case"Enter":h(e);break;case"ArrowRight":{var r;const t=u.indexOf(e.currentTarget)+1;n=null!=(r=u[t])?r:u[0];break}case"ArrowLeft":{var a;const t=u.indexOf(e.currentTarget)-1;n=null!=(a=u[t])?a:u[u.length-1];break}}null==(t=n)||t.focus()};return(0,k.jsx)("ul",{role:"tablist","aria-orientation":"horizontal",className:(0,a.Z)("tabs",{"tabs--block":n},t),children:i.map((e=>{let{value:t,label:n,attributes:o}=e;return(0,k.jsx)("li",{role:"tab",tabIndex:r===t?0:-1,"aria-selected":r===t,ref:e=>u.push(e),onKeyDown:p,onClick:h,...o,className:(0,a.Z)("tabs__item",x.tabItem,null==o?void 0:o.className,{"tabs__item--active":r===t}),children:null!=n?n:t},t)}))})}function y(e){let{lazy:t,children:n,selectedValue:a}=e;const o=(Array.isArray(n)?n:[n]).filter(Boolean);if(t){const e=o.find((e=>e.props.value===a));return e?(0,r.cloneElement)(e,{className:"margin-top--md"}):null}return(0,k.jsx)("div",{className:"margin-top--md",children:o.map(((e,t)=>(0,r.cloneElement)(e,{key:t,hidden:e.props.value!==a})))})}function b(e){const t=m(e);return(0,k.jsxs)("div",{className:(0,a.Z)("tabs-container",x.tabList),children:[(0,k.jsx)(f,{...e,...t}),(0,k.jsx)(y,{...e,...t})]})}function v(e){const t=(0,g.Z)();return(0,k.jsx)(b,{...e,children:p(e.children)},String(t))}},11151:(e,t,n)=>{n.d(t,{Z:()=>i,a:()=>s});var r=n(67294);const a={},o=r.createContext(a);function s(e){const t=r.useContext(o);return r.useMemo((function(){return"function"==typeof e?e(t):{...t,...e}}),[t,e])}function i(e){let t;return t=e.disableParentContext?"function"==typeof e.components?e.components(a):e.components||a:s(e.components),r.createElement(o.Provider,{value:t},e.children)}}}]);