"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[7947],{44032:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>u,contentTitle:()=>o,default:()=>m,frontMatter:()=>i,metadata:()=>c,toc:()=>d});var a=n(85893),l=n(11151),r=n(74866),s=n(85162);const i={title:"Email stage"},o=void 0,c={id:"flow/stages/email/index",title:"Email stage",description:"This stage can be used for email verification. authentik's background worker will send an email using the specified connection details. When an email can't be delivered, delivery is automatically retried periodically.",source:"@site/docs/flow/stages/email/index.mdx",sourceDirName:"flow/stages/email",slug:"/flow/stages/email/",permalink:"/docs/flow/stages/email/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/flow/stages/email/index.mdx",tags:[],version:"current",frontMatter:{title:"Email stage"},sidebar:"docs",previous:{title:"Deny stage",permalink:"/docs/flow/stages/deny"},next:{title:"Identification stage",permalink:"/docs/flow/stages/identification/"}},u={},d=[{value:"Behaviour",id:"behaviour",level:2},{value:"Custom Templates",id:"custom-templates",level:2},{value:"Example template",id:"example-template",level:3}];function h(e){const t={admonition:"admonition",code:"code",h2:"h2",h3:"h3",img:"img",li:"li",p:"p",pre:"pre",ul:"ul",...(0,l.a)(),...e.components};return(0,a.jsxs)(a.Fragment,{children:[(0,a.jsx)(t.p,{children:"This stage can be used for email verification. authentik's background worker will send an email using the specified connection details. When an email can't be delivered, delivery is automatically retried periodically."}),"\n",(0,a.jsx)(t.p,{children:(0,a.jsx)(t.img,{src:n(5459).Z+"",width:"541",height:"531"})}),"\n",(0,a.jsx)(t.h2,{id:"behaviour",children:"Behaviour"}),"\n",(0,a.jsxs)(t.p,{children:["By default, the email is sent to the currently pending user. To override this, you can set ",(0,a.jsx)(t.code,{children:"email"})," in the plan's context to another email address, which will override the user's email address (the user won't be changed)."]}),"\n",(0,a.jsx)(t.p,{children:"For example, create this expression policy and bind it to the email stage:"}),"\n",(0,a.jsx)(t.pre,{children:(0,a.jsx)(t.code,{className:"language-python",children:'request.context["flow_plan"].context["email"] = "foo@bar.baz"\n# Or get it from a prompt\n# request.context["flow_plan"].context["email"] = request.context["prompt_data"]["email"]\n# Or another user attribute\n# request.context["flow_plan"].context["email"] = request.context["pending_user"].attributes.get("otherEmail")\nreturn True\n'})}),"\n",(0,a.jsx)(t.h2,{id:"custom-templates",children:"Custom Templates"}),"\n",(0,a.jsx)(t.p,{children:"You can also use custom email templates, to use your own design or layout."}),"\n",(0,a.jsx)(t.admonition,{type:"info",children:(0,a.jsxs)(t.p,{children:["Starting with authentik 2024.2, it is possible to create ",(0,a.jsx)(t.code,{children:".txt"})," files with the same name as the ",(0,a.jsx)(t.code,{children:".html"})," template. If a matching ",(0,a.jsx)(t.code,{children:".txt"})," file exists, the email sent will be a multipart email with both the text and HTML template."]})}),"\n","\n",(0,a.jsxs)(r.Z,{defaultValue:"docker-compose",values:[{label:"docker-compose",value:"docker-compose"},{label:"Kubernetes",value:"kubernetes"}],children:[(0,a.jsx)(s.Z,{value:"docker-compose",children:(0,a.jsxs)(t.p,{children:["Place any custom templates in the ",(0,a.jsx)(t.code,{children:"custom-templates"})," Folder, which is in the same folder as your docker-compose file. Afterwards, you'll be able to select the template when creating/editing an Email stage."]})}),(0,a.jsxs)(s.Z,{value:"kubernetes",children:[(0,a.jsx)(t.p,{children:"Create a ConfigMap with your email templates:"}),(0,a.jsx)(t.pre,{children:(0,a.jsx)(t.code,{className:"language-yaml",children:"apiVersion: v1\nkind: ConfigMap\nmetadata:\n    name: authentik-templates\n    namespace: authentik\ndata:\n    my-template.html: |\n        <tr>...\n"})}),(0,a.jsxs)(t.p,{children:["Then, in the helm chart add this to your ",(0,a.jsx)(t.code,{children:"values.yaml"})," file:"]}),(0,a.jsx)(t.pre,{children:(0,a.jsx)(t.code,{className:"language-yaml",children:"volumes:\n    - name: email-templates\n      configMap:\n          name: authentik-templates\nvolumeMounts:\n    - name: email-templates\n      mountPath: /templates\n"})})]})]}),"\n",(0,a.jsx)(t.admonition,{type:"info",children:(0,a.jsxs)(t.p,{children:["If you've add the line and created a file, and can't see if, check the worker logs using ",(0,a.jsx)(t.code,{children:"docker compose logs -f worker"})," or ",(0,a.jsx)(t.code,{children:"kubectl logs -f deployment/authentik-worker"}),"."]})}),"\n",(0,a.jsx)(t.p,{children:(0,a.jsx)(t.img,{src:n(18663).Z+"",width:"682",height:"686"})}),"\n",(0,a.jsx)(t.h3,{id:"example-template",children:"Example template"}),"\n",(0,a.jsx)(t.p,{children:"Templates are rendered using Django's templating engine. The following variables can be used:"}),"\n",(0,a.jsxs)(t.ul,{children:["\n",(0,a.jsxs)(t.li,{children:[(0,a.jsx)(t.code,{children:"url"}),": The full URL for the user to click on"]}),"\n",(0,a.jsxs)(t.li,{children:[(0,a.jsx)(t.code,{children:"user"}),": The pending user object."]}),"\n",(0,a.jsxs)(t.li,{children:[(0,a.jsx)(t.code,{children:"expires"}),": The timestamp when the token expires."]}),"\n"]}),"\n",(0,a.jsx)(t.pre,{children:(0,a.jsx)(t.code,{className:"language-html",children:'{# This is how you can write comments which aren\'t rendered. #}\n{# Extend this template from the base email template, which includes base layout and CSS. #}\n{% extends "email/base.html" %}\n{# Load the internationalization module to translate strings, and humanize to show date-time #}\n{% load i18n %}\n{% load humanize %}\n{# The email/base.html template uses a single "content" block #}\n{% block content %}\n<tr>\n    <td class="alert alert-success">\n        {% blocktrans with username=user.username %} Hi {{ username }}, \n        {% endblocktrans %}\n    </td>\n</tr>\n<tr>\n    <td class="content-wrap">\n        <table width="100%" cellpadding="0" cellspacing="0">\n            <tr>\n                <td class="content-block">\n                    {% trans \'You recently requested to change your password for you authentik account. Use the button below to set a new password.\' %}                    \n                </td>\n            </tr>\n            <tr>\n                <td class="content-block">\n                    <table\n                        role="presentation"\n                        border="0"\n                        cellpadding="0"\n                        cellspacing="0"\n                        class="btn btn-primary"\n                    >\n                        <tbody>\n                            <tr>\n                                <td align="center">\n                                    <table\n                                        role="presentation"\n                                        border="0"\n                                        cellpadding="0"\n                                        cellspacing="0"\n                                    >\n                                        <tbody>\n                                            <tr>\n                                                <td>\n                                                    <a\n                                                        id="confirm"\n                                                        href="{{ url }}"\n                                                        rel="noopener noreferrer"\n                                                        target="_blank"\n                                                        >{% trans \'Reset Password\' %}</a\n                                                    >\n                                                </td>\n                                            </tr>\n                                        </tbody>\n                                    </table>\n                                </td>\n                            </tr>\n                        </tbody>\n                    </table>\n                </td>\n            </tr>\n            <tr>\n                <td class="content-block">\n                    {% blocktrans with expires=expires|naturaltime %}\n                    If you did not request a password change, please ignore this Email. The link above is valid for {{ expires }}.\n                    {% endblocktrans %}\n                </td>\n            </tr>\n        </table>\n    </td>\n</tr>\n{% endblock %}\n'})})]})}function m(e={}){const{wrapper:t}={...(0,l.a)(),...e.components};return t?(0,a.jsx)(t,{...e,children:(0,a.jsx)(h,{...e})}):h(e)}},85162:(e,t,n)=>{n.d(t,{Z:()=>s});n(67294);var a=n(90512);const l={tabItem:"tabItem_Ymn6"};var r=n(85893);function s(e){let{children:t,hidden:n,className:s}=e;return(0,r.jsx)("div",{role:"tabpanel",className:(0,a.Z)(l.tabItem,s),hidden:n,children:t})}},74866:(e,t,n)=>{n.d(t,{Z:()=>k});var a=n(67294),l=n(90512),r=n(12466),s=n(16550),i=n(20469),o=n(91980),c=n(67392),u=n(50012);function d(e){var t,n;return null!=(t=null==(n=a.Children.toArray(e).filter((e=>"\n"!==e)).map((e=>{if(!e||(0,a.isValidElement)(e)&&function(e){const{props:t}=e;return!!t&&"object"==typeof t&&"value"in t}(e))return e;throw new Error("Docusaurus error: Bad <Tabs> child <"+("string"==typeof e.type?e.type:e.type.name)+'>: all children of the <Tabs> component should be <TabItem>, and every <TabItem> should have a unique "value" prop.')})))?void 0:n.filter(Boolean))?t:[]}function h(e){const{values:t,children:n}=e;return(0,a.useMemo)((()=>{const e=null!=t?t:function(e){return d(e).map((e=>{let{props:{value:t,label:n,attributes:a,default:l}}=e;return{value:t,label:n,attributes:a,default:l}}))}(n);return function(e){const t=(0,c.l)(e,((e,t)=>e.value===t.value));if(t.length>0)throw new Error('Docusaurus error: Duplicate values "'+t.map((e=>e.value)).join(", ")+'" found in <Tabs>. Every value needs to be unique.')}(e),e}),[t,n])}function m(e){let{value:t,tabValues:n}=e;return n.some((e=>e.value===t))}function p(e){let{queryString:t=!1,groupId:n}=e;const l=(0,s.k6)(),r=function(e){let{queryString:t=!1,groupId:n}=e;if("string"==typeof t)return t;if(!1===t)return null;if(!0===t&&!n)throw new Error('Docusaurus error: The <Tabs> component groupId prop is required if queryString=true, because this value is used as the search param name. You can also provide an explicit value such as queryString="my-search-param".');return null!=n?n:null}({queryString:t,groupId:n});return[(0,o._X)(r),(0,a.useCallback)((e=>{if(!r)return;const t=new URLSearchParams(l.location.search);t.set(r,e),l.replace({...l.location,search:t.toString()})}),[r,l])]}function b(e){const{defaultValue:t,queryString:n=!1,groupId:l}=e,r=h(e),[s,o]=(0,a.useState)((()=>function(e){var t;let{defaultValue:n,tabValues:a}=e;if(0===a.length)throw new Error("Docusaurus error: the <Tabs> component requires at least one <TabItem> children component");if(n){if(!m({value:n,tabValues:a}))throw new Error('Docusaurus error: The <Tabs> has a defaultValue "'+n+'" but none of its children has the corresponding value. Available values are: '+a.map((e=>e.value)).join(", ")+". If you intend to show no default tab, use defaultValue={null} instead.");return n}const l=null!=(t=a.find((e=>e.default)))?t:a[0];if(!l)throw new Error("Unexpected error: 0 tabValues");return l.value}({defaultValue:t,tabValues:r}))),[c,d]=p({queryString:n,groupId:l}),[b,f]=function(e){let{groupId:t}=e;const n=function(e){return e?"docusaurus.tab."+e:null}(t),[l,r]=(0,u.Nk)(n);return[l,(0,a.useCallback)((e=>{n&&r.set(e)}),[n,r])]}({groupId:l}),g=(()=>{const e=null!=c?c:b;return m({value:e,tabValues:r})?e:null})();(0,i.Z)((()=>{g&&o(g)}),[g]);return{selectedValue:s,selectValue:(0,a.useCallback)((e=>{if(!m({value:e,tabValues:r}))throw new Error("Can't select invalid tab value="+e);o(e),d(e),f(e)}),[d,f,r]),tabValues:r}}var f=n(72389);const g={tabList:"tabList__CuJ",tabItem:"tabItem_LNqP"};var x=n(85893);function v(e){let{className:t,block:n,selectedValue:a,selectValue:s,tabValues:i}=e;const o=[],{blockElementScrollPositionUntilNextRender:c}=(0,r.o5)(),u=e=>{const t=e.currentTarget,n=o.indexOf(t),l=i[n].value;l!==a&&(c(t),s(l))},d=e=>{var t;let n=null;switch(e.key){case"Enter":u(e);break;case"ArrowRight":{var a;const t=o.indexOf(e.currentTarget)+1;n=null!=(a=o[t])?a:o[0];break}case"ArrowLeft":{var l;const t=o.indexOf(e.currentTarget)-1;n=null!=(l=o[t])?l:o[o.length-1];break}}null==(t=n)||t.focus()};return(0,x.jsx)("ul",{role:"tablist","aria-orientation":"horizontal",className:(0,l.Z)("tabs",{"tabs--block":n},t),children:i.map((e=>{let{value:t,label:n,attributes:r}=e;return(0,x.jsx)("li",{role:"tab",tabIndex:a===t?0:-1,"aria-selected":a===t,ref:e=>o.push(e),onKeyDown:d,onClick:u,...r,className:(0,l.Z)("tabs__item",g.tabItem,null==r?void 0:r.className,{"tabs__item--active":a===t}),children:null!=n?n:t},t)}))})}function w(e){let{lazy:t,children:n,selectedValue:l}=e;const r=(Array.isArray(n)?n:[n]).filter(Boolean);if(t){const e=r.find((e=>e.props.value===l));return e?(0,a.cloneElement)(e,{className:"margin-top--md"}):null}return(0,x.jsx)("div",{className:"margin-top--md",children:r.map(((e,t)=>(0,a.cloneElement)(e,{key:t,hidden:e.props.value!==l})))})}function y(e){const t=b(e);return(0,x.jsxs)("div",{className:(0,l.Z)("tabs-container",g.tabList),children:[(0,x.jsx)(v,{...e,...t}),(0,x.jsx)(w,{...e,...t})]})}function k(e){const t=(0,f.Z)();return(0,x.jsx)(y,{...e,children:d(e.children)},String(t))}},18663:(e,t,n)=>{n.d(t,{Z:()=>a});const a=n.p+"assets/images/custom_template-56a56c6fe078c73e32f8f2bed9b8152e.png"},5459:(e,t,n)=>{n.d(t,{Z:()=>a});const a=n.p+"assets/images/email_recovery-2f0279d124858bbe083f1fe808093aaf.png"},11151:(e,t,n)=>{n.d(t,{Z:()=>i,a:()=>s});var a=n(67294);const l={},r=a.createContext(l);function s(e){const t=a.useContext(r);return a.useMemo((function(){return"function"==typeof e?e(t):{...t,...e}}),[t,e])}function i(e){let t;return t=e.disableParentContext?"function"==typeof e.components?e.components(l):e.components||l:s(e.components),a.createElement(r.Provider,{value:t},e.children)}}}]);