"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[9932],{79737:(e,t,n)=>{n.r(t),n.d(t,{assets:()=>r,contentTitle:()=>c,default:()=>l,frontMatter:()=>s,metadata:()=>o,toc:()=>h});var i=n(85893),a=n(11151);const s={},c="Machine-to-machine authentication",o={id:"providers/oauth2/client_credentials",title:"Machine-to-machine authentication",description:"Client credentials can be used for machine-to-machine communication authentication. Clients can authenticate themselves using service-accounts; standard clientid + clientsecret is not sufficient. This behavior is due to providers only being able to have a single secret at any given time.",source:"@site/docs/providers/oauth2/client_credentials.md",sourceDirName:"providers/oauth2",slug:"/providers/oauth2/client_credentials",permalink:"/docs/providers/oauth2/client_credentials",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/providers/oauth2/client_credentials.md",tags:[],version:"current",frontMatter:{},sidebar:"docs",previous:{title:"OAuth2 Provider",permalink:"/docs/providers/oauth2/"},next:{title:"Device code flow",permalink:"/docs/providers/oauth2/device_code"}},r={},h=[{value:"Static authentication",id:"static-authentication",level:3},{value:"JWT-authentication",id:"jwt-authentication",level:3}];function d(e){const t={a:"a",admonition:"admonition",code:"code",em:"em",h1:"h1",h3:"h3",p:"p",pre:"pre",...(0,a.a)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(t.h1,{id:"machine-to-machine-authentication",children:"Machine-to-machine authentication"}),"\n",(0,i.jsx)(t.p,{children:"Client credentials can be used for machine-to-machine communication authentication. Clients can authenticate themselves using service-accounts; standard client_id + client_secret is not sufficient. This behavior is due to providers only being able to have a single secret at any given time."}),"\n",(0,i.jsxs)(t.p,{children:["Note that authentik does treat a grant type of ",(0,i.jsx)(t.code,{children:"password"})," the same as ",(0,i.jsx)(t.code,{children:"client_credentials"})," to support applications which rely on a password grant."]}),"\n",(0,i.jsx)(t.h3,{id:"static-authentication",children:"Static authentication"}),"\n",(0,i.jsxs)(t.p,{children:["Hence identification is based on service-accounts, and authentication is based on App-password tokens. These objects can be created in a single step using the ",(0,i.jsx)(t.em,{children:"Create Service account"})," function."]}),"\n",(0,i.jsx)(t.p,{children:"An example request can look like this:"}),"\n",(0,i.jsx)(t.pre,{children:(0,i.jsx)(t.code,{children:"POST /application/o/token/ HTTP/1.1\nHost: authentik.company\nContent-Type: application/x-www-form-urlencoded\n\ngrant_type=client_credentials&\nclient_id=application_client_id&\nusername=my-service-account&\npassword=my-token\n"})}),"\n",(0,i.jsxs)(t.p,{children:["This will return a JSON response with an ",(0,i.jsx)(t.code,{children:"access_token"}),", which is a signed JWT token. This token can be sent along requests to other hosts, which can then validate the JWT based on the signing key configured in authentik."]}),"\n",(0,i.jsxs)(t.p,{children:["Starting with authentik 2024.4, it is also possible to encode the username and token of the user to authenticate with, separated with a colon, into a base64 string and pass it as ",(0,i.jsx)(t.code,{children:"client_secret"})," value."]}),"\n",(0,i.jsxs)(t.p,{children:["In addition to that, with authentik 2024.4 it is also possible to pass the configured ",(0,i.jsx)(t.code,{children:"client_secret"})," value, which will automatically generate a service account user for which the JWT token will be issued."]}),"\n",(0,i.jsx)(t.h3,{id:"jwt-authentication",children:"JWT-authentication"}),"\n",(0,i.jsx)(t.p,{children:"Starting with authentik 2022.4, you can authenticate and get a token using an existing JWT."}),"\n",(0,i.jsx)(t.p,{children:"(For readability we will refer to the JWT issued by the external issuer/platform as input JWT, and the resulting JWT from authentik as the output JWT)"}),"\n",(0,i.jsxs)(t.p,{children:["To configure this, the certificate used to sign the input JWT must be created in authentik. The certificate is enough, a private key is not required. Afterwards, configure the certificate in the OAuth2 provider settings under ",(0,i.jsx)(t.em,{children:"Verification certificates"}),"."]}),"\n",(0,i.jsx)(t.admonition,{type:"info",children:(0,i.jsx)(t.p,{children:"Starting with authentik 2022.6, you can define a JWKS URL/raw JWKS data in OAuth Sources, and use those to verify the key instead of having to manually create a certificate in authentik for them. This method is still supported but will be removed in a later version."})}),"\n",(0,i.jsx)(t.p,{children:"With this configure, any JWT issued by the configured certificates can be used to authenticate:"}),"\n",(0,i.jsx)(t.pre,{children:(0,i.jsx)(t.code,{children:"POST /application/o/token/ HTTP/1.1\nHost: authentik.company\nContent-Type: application/x-www-form-urlencoded\n\ngrant_type=client_credentials&\nclient_assertion_type=urn:ietf:params:oauth:client-assertion-type:jwt-bearer&\nclient_assertion=$inputJWT&\nclient_id=application_client_id\n"})}),"\n",(0,i.jsxs)(t.p,{children:["Alternatively, you can set the ",(0,i.jsx)(t.code,{children:"client_secret"})," parameter to the ",(0,i.jsx)(t.code,{children:"$inputJWT"}),", for applications which can set the password from a file but not other parameters."]}),"\n",(0,i.jsxs)(t.p,{children:["Input JWTs are checked to be signed by any of the selected ",(0,i.jsx)(t.em,{children:"Verification certificates"}),", and their ",(0,i.jsx)(t.code,{children:"exp"})," attribute must not be now or in the past."]}),"\n",(0,i.jsxs)(t.p,{children:["To do additional checks, you can use ",(0,i.jsx)(t.em,{children:(0,i.jsx)(t.a,{href:"../../policies/expression",children:"Expression policies"})}),":"]}),"\n",(0,i.jsx)(t.pre,{children:(0,i.jsx)(t.code,{className:"language-python",children:'return request.context["oauth_jwt"]["iss"] == "https://my.issuer"\n'})})]})}function l(e={}){const{wrapper:t}={...(0,a.a)(),...e.components};return t?(0,i.jsx)(t,{...e,children:(0,i.jsx)(d,{...e})}):d(e)}},11151:(e,t,n)=>{n.d(t,{Z:()=>o,a:()=>c});var i=n(67294);const a={},s=i.createContext(a);function c(e){const t=i.useContext(s);return i.useMemo((function(){return"function"==typeof e?e(t):{...t,...e}}),[t,e])}function o(e){let t;return t=e.disableParentContext?"function"==typeof e.components?e.components(a):e.components||a:c(e.components),i.createElement(s.Provider,{value:t},e.children)}}}]);